#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<class T>
ostream& operator<<(ostream& out, vector<T> v) {
	for (T it : v) {
		out << it << ' ';
	}
	out << '\n';
	return out;
}

#define ll long long

const int MAX = 200'005;
const int MOD = 998'244'353;

int a[MAX];

int main()
{
	int t;
	cin >> t;
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 1; i < n; i++) {
		if (a[i - 1] % 2 != a[i] % 2) {
			cout << "No";
			return 0;
		}
	}

	string s;
	cin >> s;
	cout << "Yes\n";

	if (t == 2) {
		cout << (m + 1) / 2 << '\n';
	}
	if (t == 3) {
		cout << 1 << '\n' << (m + 1) / 2 << '\n';
	}

}


